#include <LagrangeFE.h>


void compute_element_matrices(Polygon& domain, int velocity_order, int pressure_order){
  std::map<std::pair<int,int>, ex> A11, A12, A21;
  std::pair<int,int> index; 

  //FIXME: needs nsd here !!
  VectorLagrangeFE velocity_element; 
  velocity_element.set(velocity_order);
  velocity_element.set_size(2); //FIXME nsd should be fetched  from Polygon or something ?   
  velocity_element.set(domain); 
  velocity_element.compute_basis_functions(); 

  LagrangeFE pressure_element; 
  pressure_element.set(pressure_order);
  pressure_element.set(domain); 
  pressure_element.compute_basis_functions(); 

  for (int i=1; i<= velocity_element.nbf(); i++) {
    index.first =i; 
    for (int j=1; j<= velocity_element.nbf(); j++) {
      index.second=j; 
      ex nabla = inner(grad(velocity_element.N(i)), grad(velocity_element.N(j))); 
      cout <<"nabla "<<nabla<<endl; 
      cout <<"grad "<<grad(velocity_element.N(i))<<endl; 
      ex Aij = domain.integrate(nabla);   
      A11[index] = Aij;  
    }
  }
  map<std::pair<int,int>,ex>::iterator iter; 
  for (iter = A11.begin(); iter != A11.end() ; iter++) {
      cout <<"A["<<(*iter).first.first<<","<<(*iter).first.second<<"]="<<(*iter).second<<endl; 
  }

}

int main () {
  cout <<"2D ----------------------------"<<endl; 
  ReferenceTriangle triangle("t"); 
  compute_element_matrices(triangle, 2,1); 


}


