#ifndef DOF_IS_INCLUDED
#define DOF_IS_INCLUDED

#include <FE.h> 





class Dof {
  protected: 
  int counter; 
  // the structures loc2dof, dof2index, and doc2loc  are completely dynamic
  // they are all initialized and updated by insert_dof(int e, int i, ex Li) 
  
  // (int e, int i) -> ex Li 
  map<pair<int,int>, ex>          loc2dof;   
  // (ex Lj)    -> int j 
  map<ex,int,ex_is_less>          dof2index; 
  // (int j)        -> ex Lj 
  map<int,ex>                     index2dof;  
  // (ex j)    -> vector< pair<e1, i1>, ..  pair<en, in> >
  map <ex, vector<pair<int,int> >,ex_is_less >  dof2loc;     

  public: 
  Dof() { counter = 0; }
  ~Dof() {}
  int insert_dof(int e, int i, ex Li);  // to update the internal structures  

  // helper functions when the dofs have been set  
  // These do not modify the internal structure 
  int glob_dof(int e, int i); 
  int glob_dof(ex Lj); 
  ex  glob_dof(int j); 
  int size();  
  vector<pair<int, int> > glob2loc(int j); 
}; 


#endif 

