#ifndef FE_IS_INCLUDED
#define FE_IS_INCLUDED


#include <tools.h> // Lots of the tools we need is currently in tools.h. 
		   // These are functions on a lower level than the finite elements, 
		   // e.g. functions for making polynomial spaces

#include <Polygon.h>



class FE {
  public: 
  FE() {}
  ~FE() {}

  virtual void set(Polygon& p) = 0;  
  virtual ex N(int i) = 0; 
  virtual ex dof(int i) = 0 ; 
  virtual int nbf() = 0; 

  // print and debug functions (need some thought) ??    
  // if the internal structures are public and general 
  // STL objects, then such functions are not necessarilly needed
};

class StandardFE : public FE {
  protected: 
  exvector Ns; 
  exvector dofs; 
  Polygon* p; //FIXME should this be a reference ?  
  int order; 

  //a rough implementation of this element is in spectral.cpp, 
  //but there the reference element is hard coded 
  public: 
  StandardFE() {}
  ~StandardFE() {}

  void set(int order); 
  void set(Polygon& p);  
  void compute_basis_functions();  
  virtual int nbf(); 
  virtual ex N(int i);  
  virtual ex dof(int i); 
}; 



#endif

  






