#include <Polygon.h>


int Polygon::  no_vertices() {
  return p.size(); 
}

ex Polygon::vertex (int i) {
  return p[i];  
}

string Polygon:: str() {
  //FIXME could add all points here. 
  return "Polygon"; 
}


//---        Line ------------------------------------

Line:: Line(ex x0, ex x1, string subscript_){ 
   subscript = subscript_; 

  /* Lines on the form 
   * x = x_0 + a_1 t
   * y = y_0 + a_2 t
   * z = z_0 + a_3 t
  */


  //FIXME does not need to be a list in 1D. 
  if ( (is_a<lst>(x0) && is_a<lst>(x1)) && (x0.nops() == x1.nops()) ) { 

    lst aa; 
    lst bb; 


    // compute aa and bb 
    for (int i=0; i<= x0.nops()-1; i++) {
      bb.append(x0.op(i)); 
      aa.append(x1.op(i) - x0.op(i)); 
    }


    //update internal structure
    p.insert(p.end(), x0); ; 
    p.insert(p.end(), x1); ; 
    a_ = aa; 
    b_ = bb; 

  } else {
    // FIXME: not decided on proper error handling yet. 
    // Could build upon GiNaC
    cout <<"THIS SHOULD NOT HAPPEN "<<endl; 
  }
}

int Line:: no_vertices() { return 2;  }

ex Line:: vertex(int i) {
  return p[i];  
}


 
ex Line:: repr(ex t, Repr_format format) {
  /* FIXME: use the same symbols in this 
   * description as in the actual symbols 
   * below and in the documentation. 
   *
   * Lines on the form 
   * x = x_0 + a_1 t,   
   * y = y_0 + a_2 t,
   * z = z_0 + a_3 t. 
   * for t in [0,1]
  */

  lst r; 
  // 2D

  if ( format == SUBS_PERFORMED ) { 
    if ( a_.nops() == 2) { 
      r = lst(  x == b_.op(0) +  a_.op(0)*t, 
                y == b_.op(1) +  a_.op(1)*t);   
    // 3D
    } else if ( a_.nops() == 3) {
      r = lst(  x == b_.op(0) +  a_.op(0)*t, 
                y == b_.op(1) +  a_.op(1)*t,   
                z == b_.op(2) +  a_.op(2)*t);   
    }
    r.append(lst(t,0,1));
  }
  else if ( format == SUBS_NOT_PERFORMED ) { 

    // FIXME: decide how the constant should be !!
    symbol a1("A"+subscript); 
    symbol a2("C"+subscript); 
    symbol a3("E"+subscript); 
    symbol b1("B"+subscript); 
    symbol b2("D"+subscript); 
    symbol b3("F"+subscript); 
  
  
    // 3D
    if ( a_.nops() == 2) { 
      r = lst(  x == b1 +  a1*t, 
                y == b2 +  a2*t);   
  
      r.append( a1 == a_.op(0));   
      r.append( b1 == b_.op(0));
      r.append( a2 == a_.op(1)); 
      r.append( b2 == b_.op(1)); 
    // 3D
    } else if ( a_.nops() == 3) {
      r = lst(  x == b1 +  a1*t, 
                y == b2 +  a2*t,   
                z == b3 +  a3*t);   
  
  
      r.append( a1 == a_.op(0));   
      r.append( b1 == b_.op(0));
      r.append( a2 == a_.op(1)); 
      r.append( b2 == b_.op(1)); 
      r.append( a3 == a_.op(2)); 
      r.append( b3 == b_.op(2)); 
  
  
    }
  
    r.append(lst(t,0,1));
  }

  return r; 
}

ex Line:: integrate(ex f, Repr_format format) {
  symbol t("t"); 
  ex t_repr = repr(t); 
  lst sub; 
  int counter; 
  // perform substitution 
  if ( p[0].nops() == 3) {
    sub = lst(t_repr.op(0), t_repr.op(1), t_repr.op(2));  
    counter = 3;  
  } else if ( p[0].nops() == 2) { 
    sub = lst(t_repr.op(0), t_repr.op(1));  
    counter = 2;  
  }


  // compute D
  ex D; 
  if ( p[0].nops() == 3) {
    D = pow(t_repr.op(0).rhs().coeff(t), 2) +  
        pow(t_repr.op(1).rhs().coeff(t), 2) +   
        pow(t_repr.op(2).rhs().coeff(t), 2);  
  } else if ( p[0].nops() == 2) { 
    D = pow(t_repr.op(0).rhs().coeff(t), 2) +  
        pow(t_repr.op(1).rhs().coeff(t), 2);  
  }

  D = sqrt(D); 

  ex intf = f.subs(sub)*D; 

  intf = integral(t_repr.op(counter).op(0), t_repr.op(counter).op(1), t_repr.op(counter).op(2), intf);  
  intf = eval_integ(intf); 

  return intf; 


}

string Line:: str(){
   std::ostringstream s; 
   s <<"Line("<<p[0]<<","<<p[1]<<")"; 
   return s.str(); 
}


//---        ReferenceLine --------------------------------

ReferenceLine:: ReferenceLine(string subscript_) {
  subscript = subscript_; 
  ex x0 = lst(0,0,0); 
  ex x1 = lst(1,0,0); 


}

int ReferenceLine:: no_vertices() { return 2; }

ex ReferenceLine:: vertex(int i) {
  return p[i]; 
}

ex ReferenceLine:: a() {
  return lst(1,0,0);  
}

ex ReferenceLine:: b() {
  return lst(0,0,0); 
}

ex ReferenceLine:: repr(ex t, Repr_format format) {
  lst r; 
  r = lst( x == t, y == 0, z == 0, t, 0, 1);  
  return r; 
}

string ReferenceLine:: str() {
   std::ostringstream s; 
//   s <<"ReferenceLine("<<p[0]<<","<<p[1]<<")"<<endl; 
   s <<"ReferenceLine"; // <<endl; 
   return s.str(); 
}

ex ReferenceLine:: integrate(ex f, Repr_format formt) {
  ex intf = integral(x,0,1,f);   
  intf =  eval_integ(intf); 
  return intf;  
}


//---        Triangle ------------------------------------

Triangle:: Triangle(ex x0, ex x1, ex x2, string subscript_) { 
  subscript = subscript_; 
  p.insert(p.end(), x0); 
  p.insert(p.end(), x1); 
  p.insert(p.end(), x2); 

}

int Triangle:: no_vertices() { return 3; }

ex Triangle:: vertex(int i) {
  return p[i]; 
}

/*
ex Triangle:: plane() {
  lst ret; 

  if ( p[1].nops() == 3 ) {
   
    lst x1x0; // = ex_to<lst>(p[1] - p[0]); 
    lst x2x0; // = ex_to<lst>(p[2] - p[0]); 
    for (int i=0; i<= p[0].nops()-1; i++) {
      x1x0.append(p[1].op(i)-p[0].op(i));  
      x2x0.append(p[2].op(i)-p[0].op(i));  
    }
   
    lst normal = cross(x1x0, x2x0); 
   
    cout <<endl; 
  
    symbol A("A"); symbol B("B"); symbol C("C"); 
    ret.append(normal.op(0)*(x- p[0].op(0)));
    ret.append(normal.op(1)*(y- p[0].op(1)));
    ret.append(normal.op(2)*(z- p[0].op(2)));
  } else {
    ret.append(z == 0 ); 
  }
 return ret; 
}
*/

Line Triangle:: line(int i) {
//  Line l = Line(p[(i-1)%3], p[i%3]); 
//  return l; 
  if      ( i == 1) return Line(p[0],p[1], istr(subscript,i));  
  else if ( i == 2) return Line(p[0],p[2], istr(subscript,i));  
  else if ( i == 3) return Line(p[1],p[2], istr(subscript,i));  
}

ex Triangle:: repr(Repr_format format) {
   symbol r("r"), s("s"); 
   symbol G("G"), H("H"); 
   ex l1_repr = line(1).repr(r); 
   ex l2_repr = line(2).repr(s); 
   lst ret; 
   //2D 
   if ( p[0].nops() == 2) {
     ret = lst( x ==l1_repr.op(0).rhs().coeff(r,0) + l1_repr.op(0).rhs().coeff(r,1)*r +  l2_repr.op(0).rhs().coeff(s,1)*s,  
                y ==l1_repr.op(1).rhs().coeff(r,0) + l1_repr.op(1).rhs().coeff(r,1)*r +  l2_repr.op(1).rhs().coeff(s,1)*s);   


   }
   else if ( p[0].nops() == 3) {

     ret = lst( x == l1_repr.op(0).rhs().coeff(r,0) + l1_repr.op(0).rhs().coeff(r,1)*r +  l2_repr.op(0).rhs().coeff(s,1)*s,  
                y == l1_repr.op(1).rhs().coeff(r,0) + l1_repr.op(1).rhs().coeff(r,1)*r +  l2_repr.op(1).rhs().coeff(s,1)*s,   
                z == l1_repr.op(2).rhs().coeff(r,0) + l1_repr.op(2).rhs().coeff(r,1)*r +  l2_repr.op(2).rhs().coeff(s,1)*s);   

   }

   ret.append(lst(r, 0, 1)); 
   ret.append(lst(s, 0, 1 - r)); 

   return ret; 

}


string Triangle:: str() {
   std::ostringstream s; 
//   s <<"Triangle("<<p[0]<<","<<p[1]<<","<<p[2]<<")"<<endl; 
   s <<"Triangle"; 
   return s.str(); 
}

ex Triangle:: integrate(ex func, Repr_format format) {

  ex t_repr = repr(); 
  lst sub; 
  int counter; 


  // perform substitution
  if ( p[0].nops() == 3) {
    sub = lst(t_repr.op(0), t_repr.op(1), t_repr.op(2));  
    counter = 3;  
  } else if ( p[0].nops() == 2) { 
    sub = lst(t_repr.op(0), t_repr.op(1));  
    counter = 2;  
  }
  ex intf = func.subs(sub); 

  // compute D
  ex D; 
  if ( p[0].nops() == 3) {
    ex r = t_repr.op(3).op(0); 
    ex s = t_repr.op(4).op(0); 
    ex a = t_repr.op(0).rhs().coeff(r,1); 
    ex b = t_repr.op(0).rhs().coeff(s,1); 
    ex c = t_repr.op(1).rhs().coeff(r,1); 
    ex d = t_repr.op(1).rhs().coeff(s,1); 
    ex e = t_repr.op(2).rhs().coeff(r,1); 
    ex f = t_repr.op(2).rhs().coeff(s,1); 
    D = pow(c*f-d*e,2) + pow(a*f - b*e,2) + pow(a*d - b*c,2);   
    D = sqrt(D); 
  } else if ( p[0].nops() == 2) { 
    ex r = t_repr.op(2).op(0); 
    ex s = t_repr.op(3).op(0); 
    ex a = t_repr.op(0).rhs().coeff(r,1); 
    ex b = t_repr.op(0).rhs().coeff(s,1); 
    ex c = t_repr.op(1).rhs().coeff(r,1); 
    ex d = t_repr.op(1).rhs().coeff(s,1); 
    D = a*d-b*c; 
  }

  intf = intf*D; 


  counter++; 
  intf = integral(t_repr.op(counter).op(0), t_repr.op(counter).op(1), t_repr.op(counter).op(2), intf);  
  intf = eval_integ(intf); 

  counter--; 
  intf = integral(t_repr.op(counter).op(0), t_repr.op(counter).op(1), t_repr.op(counter).op(2), intf);  
  intf = eval_integ(intf); 
  return intf; 



/* OLD Code: 
  symbol r("r"); symbol s("s"); symbol t("t"); 
  lst v = lst(r,s,t); 

  ex line1_repr = line(1).repr(v.op(0), SUBS_NOT_PERFORMED); 
  ex line2_repr = line(2).repr(v.op(1), SUBS_NOT_PERFORMED); 
  ex line3_repr = line(3).repr(v.op(2), SUBS_NOT_PERFORMED); 
  lst new_coor; 
  // Coordinates (x,y) represented as functions of (r,s)
  // FIXME:: this depends on nsd, 4 is another number in 3D 
  for (int i=0; i<= line1_repr.nops()-4; i++) { 
    // FIXME: (x_0, y_0, z_0) is not appended ??? 
    new_coor.append(line1_repr.op(i).lhs() 
       == (line1_repr.op(i).rhs() + line2_repr.op(i).rhs())); 
  }
		    

  // compute t as a function of s 
  lst equations;  
  equations.append(new_coor.op(0).rhs() - line3_repr.op(0).rhs() == 0 ); 
  equations.append(new_coor.op(1).rhs() - line3_repr.op(1).rhs() == 0 ); 
//FIXME: only in 3D 
//  equations.append(new_coor.op(2).rhs() - line3_repr.op(2).rhs() == 0 ); 

  ex intf; 
  try {
    ex ss = lsolve( lst(equations.op(0), equations.op(1)), 
		    lst(v.op(0), v.op(2)));   
    ss = ss.op(0).rhs().collect(s); 

    symbol A("A"), B("B"); 
    ex sss = A*s + B; 

    intf = eval_integ(integral(s, 0,1, eval_integ(integral(r,0, sss, f.subs(new_coor)))));   
    return lst(intf, A == ss.coeff(s,1), B == ss.coeff(s,0),
	       line1_repr.op(2), line1_repr.op(3), line1_repr.op(4), line1_repr.op(5), 
	       line2_repr.op(2), line2_repr.op(3), line2_repr.op(4), line2_repr.op(5), 
	       line3_repr.op(2), line3_repr.op(3), line3_repr.op(4), line3_repr.op(5));  

  } catch (exception &p) {
        cerr << p.what() << endl;
  }

  // FIXME should probably return something else in case of fault
  return infinity; 
  */
}



//---        ReferenceTriangle ----------------------------


ReferenceTriangle:: ReferenceTriangle(string subscript_) { 
  subscript = subscript_; 
  ex x0 = lst(0,0,0); 
  ex x1 = lst(1,0,0); 
  ex x2 = lst(0,1,0); 
  p.insert(p.end(), x0); 
  p.insert(p.end(), x1); 
  p.insert(p.end(), x2); 
}

int ReferenceTriangle:: no_vertices() { return 3; }

ex ReferenceTriangle:: vertex (int i) {
  return Triangle::vertex(i); 
}

//ex ReferenceTriangle:: plane() {
//  return Triangle:: plane(); 
//}

Line ReferenceTriangle:: line(int i) {
  return Triangle:: line(i); 
}

ex ReferenceTriangle:: repr(Repr_format format) {
  return Triangle:: repr(); 
}
  
string ReferenceTriangle:: str() {
   std::ostringstream s; 
//   s <<"ReferenceTriangle("<<p[0]<<","<<p[1]<<","<<p[2]<<")"; 
   s <<"ReferenceTriangle"; 
   return s.str(); 
}

ex ReferenceTriangle:: integrate(ex f) {
  //FIXME can not have two integrals and then two eval_integ ? 
  ex ret = eval_integ(integral(y,0,1, eval_integ(integral(x,0,1-y,f))));   
  return ret;  
}




//---        Tetrahedron ------------------------------------


Tetrahedron:: Tetrahedron(ex x0, ex x1, ex x2, ex x3, string subscript_) { 
  subscript = subscript_; 
  p.insert(p.end(), x0); 
  p.insert(p.end(), x1); 
  p.insert(p.end(), x2); 
  p.insert(p.end(), x3); 

}

int Tetrahedron:: no_vertices() {return 4; }

ex Tetrahedron:: vertex(int i) {
  return p[i]; 
}

Line Tetrahedron:: line(int i) {
  int i0, i1; 
  if ( i == 1 ) {
    i0 = 0; i1 = 1;  
  } else if ( i == 2 ) { 
    i0 = 0; i1 = 2;  
  } else if ( i == 3 )  { 
    i0 = 0; i1 = 3;  
  } else if ( i == 4 )  { 
    i0 = 1; i1 = 2;  
  } else if ( i == 5 )  { 
    i0 = 1; i1 = 3;  
  } else if ( i == 6 )  { 
    i0 = 2; i1 = 3;  
  }
  Line l = Line(p[i0], p[i1], istr(subscript,i)); 
  return l; 
}

Triangle Tetrahedron :: triangle(int i) {
  Triangle t = Triangle(p[i%4], p[(i+1)%4], p[(i+2)%4], istr(subscript,i)); 
  return t; 
}

string Tetrahedron:: str() {
   std::ostringstream s; 
//   s <<"Tetrahedron("<<p[0]<<","<<p[1]<<","<<p[2]<<","<<p[3]<<")"; 
   s <<"Tetrahedron";
   return s.str(); 
}


ex Tetrahedron:: repr(Repr_format format) {
   symbol r("r"), s("s"), t("t"); 
   ex l1_repr = line(1).repr(r); 
   ex l2_repr = line(2).repr(s); 
   ex l3_repr = line(3).repr(t); 
   lst ret; 


   ret = lst( 
       x == l1_repr.op(0).rhs().coeff(r,0)   + l1_repr.op(0).rhs().coeff(r,1)*r 
         +  l2_repr.op(0).rhs().coeff(s,1)*s + l3_repr.op(0).rhs().coeff(t,1)*t,  
       y == l1_repr.op(1).rhs().coeff(r,0)   + l1_repr.op(1).rhs().coeff(r,1)*r 
         +  l2_repr.op(1).rhs().coeff(s,1)*s + l3_repr.op(1).rhs().coeff(t,1)*t,  
       z == l1_repr.op(2).rhs().coeff(r,0)   + l1_repr.op(1).rhs().coeff(r,1)*r  
         +  l2_repr.op(2).rhs().coeff(s,1)*s + l3_repr.op(2).rhs().coeff(t,1)*t);   


   ret.append(lst(r, 0, 1)); 
   ret.append(lst(s, 0, 1 - r)); 
   ret.append(lst(t, 0, 1 - r - s)); 

   return ret; 
}

ex Tetrahedron:: integrate(ex func, Repr_format format) {
  ex t_repr = repr(); 

  //perform substitution
  lst sub = lst(t_repr.op(0), t_repr.op(1), t_repr.op(2));  
  ex intf = func.subs(sub); 

  // compute D 
  ex D; 
  ex r = t_repr.op(3).op(0); 
  ex s = t_repr.op(4).op(0); 
  ex t = t_repr.op(5).op(0); 
  ex a = t_repr.op(0).rhs().coeff(r,1); 
  ex b = t_repr.op(0).rhs().coeff(s,1); 
  ex c = t_repr.op(0).rhs().coeff(t,1); 
  ex d = t_repr.op(1).rhs().coeff(r,1); 
  ex e = t_repr.op(1).rhs().coeff(s,1); 
  ex f = t_repr.op(1).rhs().coeff(t,1); 
  ex g = t_repr.op(2).rhs().coeff(r,1); 
  ex h = t_repr.op(2).rhs().coeff(s,1); 
  ex k = t_repr.op(2).rhs().coeff(t,1); 

  D = a*(e*k-f*h) - b*(d*k-f*g) + c*(d*h - g*e); 

  intf = intf*D; 

  intf = integral(t_repr.op(5).op(0), t_repr.op(5).op(1), t_repr.op(5).op(2), intf);  
  intf = eval_integ(intf); 

  intf = integral(t_repr.op(4).op(0), t_repr.op(4).op(1), t_repr.op(4).op(2), intf);  
  intf = eval_integ(intf); 

  intf = integral(t_repr.op(3).op(0), t_repr.op(3).op(1), t_repr.op(3).op(2), intf);  
  intf = eval_integ(intf); 

  return intf; 
}

//---        ReferenceTetrahedron ---------------------------

ReferenceTetrahedron:: ReferenceTetrahedron(string subscript_) : Tetrahedron(subscript_) {
  subscript = subscript_;  
  ex x0 = lst(0, 0, 0); 
  ex x1 = lst(1, 0, 0); 
  ex x2 = lst(0, 1, 0); 
  ex x3 = lst(0, 0, 1); 

  p.insert(p.end(), x0); 
  p.insert(p.end(), x1); 
  p.insert(p.end(), x2); 
  p.insert(p.end(), x3); 
}

int ReferenceTetrahedron:: no_vertices () {
   return 4; 
}

ex ReferenceTetrahedron:: vertex(int i) {
   return Tetrahedron:: vertex(i); 
}

Line ReferenceTetrahedron:: line(int i) {
   return Tetrahedron:: line(i); 
}

Triangle ReferenceTetrahedron :: triangle(int i) {
   return Tetrahedron:: triangle(i); 
}

string ReferenceTetrahedron:: str() {
   std::ostringstream s; 
//   s <<"ReferenceTetrahedron("<<p[0]<<","<<p[1]<<","<<p[2]<<","<<p[3]<<")"<<endl; 
   s <<"ReferenceTetrahedron"; 
   return s.str(); 
}

ex ReferenceTetrahedron:: integrate(ex f, Repr_format format) {
  // FIXME can not have two integrals and then two eval_integ ? 
  // Does not integrate over 3D. 
  
  ex intf = integral(x,0,1-y-z,f); 
  intf = eval_integ(intf); 

  intf = integral(y,0,1-z, intf); 
  intf = eval_integ(intf); 

  intf = integral(z,0,1, intf);  
  intf = eval_integ(intf); 

  return intf;  
}


//--  tools for Polygons ------------------------------------------------------ 

lst bezier_ordinates(Tetrahedron& tetrahedra, int d) {

  //FIXME: ugly conversion to matrix 

  lst ret; 
  ex V1 = tetrahedra.vertex(0); 
  ex V2 = tetrahedra.vertex(1); 
  ex V3 = tetrahedra.vertex(2); 
  ex V4 = tetrahedra.vertex(3); 

  lst V1l = ex_to<lst>(V1); 
  lst V2l = ex_to<lst>(V2); 
  lst V3l = ex_to<lst>(V3); 
  lst V4l = ex_to<lst>(V4); 


  ex V1m  = lst_to_matrix2(V1l); 
  ex V2m  = lst_to_matrix2(V2l); 
  ex V3m  = lst_to_matrix2(V3l); 
  ex V4m  = lst_to_matrix2(V4l); 

  int l; 
  for (int i=0; i<= d; i++) {
    for (int j=0; j<= d; j++) {
      for (int k=0; k<= d; k++) {
	if ( d - i - j -k  >= 0 ) { 
          l= d - i - j -k; 
          ex sum = (i*V1m + j*V2m + k*V3m + l*V4m)/d;  
          ret.append(matrix_to_lst2(sum.evalm())); 
	}
      }
    }
  }
  // FIXME how should these be sorted ?????  
  // ret = ret.sort(); 
  return ret; 
}



lst bezier_ordinates(Triangle& triangle, int d) {

  //FIXME: ugly conversion to matrix 

  lst ret; 
  ex V1 = triangle.vertex(0); 
  ex V2 = triangle.vertex(1); 
  ex V3 = triangle.vertex(2); 

  lst V1l = ex_to<lst>(V1); 
  lst V2l = ex_to<lst>(V2); 
  lst V3l = ex_to<lst>(V3); 

  ex V1m  = lst_to_matrix2(V1l); 
  ex V2m  = lst_to_matrix2(V2l); 
  ex V3m  = lst_to_matrix2(V3l); 

  int k; 
  for (int i=0; i<= d; i++) {
    for (int j=0; j<= d-i; j++) {
      k= d - i - j; 
      ex sum = (i*V1m + j*V2m + k*V3m)/d;  
      ret.append(matrix_to_lst2(sum.evalm())); 
    }
  }
  // FIXME how should these be sorted ?????  
  // ret = ret.sort(); 
  return ret; 
}

ex barycenter_triangle(ex p0, ex p1, ex p2) {
 // 2D
 symbol b0("b0"), b1("b1"), b2("b2");
 ex eq1 = x == b0*p0.op(0) + b1*p1.op(0) + b2*p2.op(0); 
 ex eq2 = y == b0*p0.op(1) + b1*p1.op(1) + b2*p2.op(1); 
 ex eq3 = 1 == b0 + b1 + b2; 

 ex sol = lsolve(lst(eq1, eq2, eq3), lst(b0, b1, b2)); 

 return sol; 
}

ex barycenter_tetrahedron(ex p0, ex p1, ex p2, ex p3) {
 symbol b0("b0"), b1("b1"), b2("b2"), b3("b3");

 // 3D 
 ex eq1 = x == b0*p0.op(0) + b1*p1.op(0) + b2*p2.op(0) + b3*p3.op(0); 
 ex eq2 = y == b0*p0.op(1) + b1*p1.op(1) + b2*p2.op(1) + b3*p3.op(1); 
 ex eq3 = z == b0*p0.op(2) + b1*p1.op(2) + b2*p2.op(2) + b3*p3.op(2); 
 ex eq4 = 1 == b0 + b1 + b2 +b3; 

 ex sol = lsolve(lst(eq1, eq2, eq3, eq4), lst(b0, b1, b2, b3)); 

 return sol; 

}




