#include <SyFi.h>


int main() {
    Triangle t(lst(0,0), lst(1,0), lst(0,1));  
    int order = 2; 
    ex polynom; 
    lst variables; 

    // the polynomial spaces on the form: 
    //      a0 + a1*x + a2*y + a3*x^2 + a4*x*y ...
    polynom = pol(order, 2, "b"); 
    // the variables a0,a1,a2 ..
    variables = coeffs(polynom); 
  
    ex Nj; 
    // The bezier ordinates in which the basis function should be either 0 or 1
    lst points = bezier_ordinates(t,order); 

    // Loop over all basis functions N_j and all points xi. 
    // Each basis function N_j is determined by a set of linear equations: 
    //   N_j(x_i) = dirac(i,j) 
    // This system of equations is then solved by lsolve
    for (int j=1; j <= points.nops(); j++) {
      lst equations; 
      int i=0; 
      for (int i=1; i<= points.nops() ; i++ ) { 
	// The point x_i 
	ex point = points.op(i-1); 
        // The equation N_j(x_i) = dirac(i,j)  
        ex eq = polynom == dirac(i,j); 
	// The equation is appended to the list of equations
        equations.append(eq.subs(lst(x == point.op(0) , y == point.op(1))));  
      }


      // We solve the linear system 
      ex subs = lsolve(equations, variables); 
      // Substitute to get the N_j 
      Nj = polynom.subs(subs);   
      cout <<"Nj "<<Nj<<endl; 
    }

}


