#include <SyFi.h>

int main() {

  symbol x0("x0"), x1("x1"), y0("y0"), y1("y1"), z0("z0"), z1("z1");
  
  ex p0 = lst(x0,y0,z0);
  ex p1 = lst(x1,y1,z1);
  
  Line line(p0,p1);
  
  symbol t("t"); 
  ex l_repr = line.repr(t);
  cout <<"l.repr "<<l_repr<<endl; 
  EQUAL_OR_DIE(l_repr, "{x==t*(x1-x0)+x0,y==y0+(-y0+y1)*t,z==z0+(z1-z0)*t,{t,0,1}}");

  for (int i=0; i< l_repr.nops(); i++) {
    cout <<"l_repr.op(" <<i<<"):  "<<l_repr.op(i)<<endl; 
  }
  
  ex f = x*x + y*y*y + z;
  ex intf = line.integrate(f); 
  cout <<"intf "<<intf<<endl; 
  EQUAL_OR_DIE(intf, "1/4*sqrt(y0^2+z0^2+x1^2-2*x1*x0+y1^2-2*z1*z0-2 *y0*y1+z1^2+x0^2)*y0^3+1/3*sqrt(y0^2+z0^2+x1^2-2*x1*x0+y1^2-2*z1*z0-2*y0*y1+z1^2 +x0^2)*x1^2+1/4*sqrt(y0^2+z0^2+x1^2-2*x1*x0+y1^2-2*z1*z0-2*y0*y1+z1^2+x0^2)*y0*y 1^2+1/2*sqrt(y0^2+z0^2+x1^2-2*x1*x0+y1^2-2*z1*z0-2*y0*y1+z1^2+x0^2)*z0+1/4*sqrt( y0^2+z0^2+x1^2-2*x1*x0+y1^2-2*z1*z0-2*y0*y1+z1^2+x0^2)*y1^3+1/4*sqrt(y0^2+z0^2+x 1^2-2*x1*x0+y1^2-2*z1*z0-2*y0*y1+z1^2+x0^2)*y0^2*y1+1/3*sqrt(y0^2+z0^2+x1^2-2*x1 *x0+y1^2-2*z1*z0-2*y0*y1+z1^2+x0^2)*x1*x0+1/3*sqrt(y0^2+z0^2+x1^2-2*x1*x0+y1^2-2 *z1*z0-2*y0*y1+z1^2+x0^2)*x0^2+1/2*sqrt(y0^2+z0^2+x1^2-2*x1*x0+y1^2-2*z1*z0-2*y0 *y1+z1^2+x0^2)*z1"); 
		

  return 0; 
}

