#include <SyFi.h> 

int main() {

  symbol x0("x0"), x1("x1"), y0("y0"), y1("y1"), z0("z0"); 
  
  ex p0 = lst(x0,y0,z0);
  ex p1 = lst(x1,y0,z0);
  ex p2 = lst(x0,y1,z0);

  Triangle triangle(p0,p1,p2);
  
  ex repr = triangle.repr();
  cout <<"t.repr "<<repr<<endl; 
  EQUAL_OR_DIE(repr, "{x==x0+r*(x1-x0),y==y0+(-y0+y1)*s,z==z0,{r,0,1},{s,0,1-r}}"); 
  
  ex f = x*y*z;
  ex intf = triangle.integrate(f); 
  cout <<"intf "<<intf<<endl; 
  EQUAL_OR_DIE(intf, "5/24*y0*x0*sqrt(-2*y0^2*x1*x0-2*y0*x0^2*y1 +y0^2*x1^2+x1^2*y1^2+4*y0*x1*x0*y1-2*x1*x0*y1^2+x0^2*y1^2-2*y0*x1^2*y1+y0^2*x0^2 )*z0+1/8*x0*sqrt(-2*y0^2*x1*x0-2*y0*x0^2*y1+y0^2*x1^2+x1^2*y1^2+4*y0*x1*x0*y1-2* x1*x0*y1^2+x0^2*y1^2-2*y0*x1^2*y1+y0^2*x0^2)*z0*y1+1/8*y0*x1*sqrt(-2*y0^2*x1*x0- 2*y0*x0^2*y1+y0^2*x1^2+x1^2*y1^2+4*y0*x1*x0*y1-2*x1*x0*y1^2+x0^2*y1^2-2*y0*x1^2* y1+y0^2*x0^2)*z0+1/24*x1*sqrt(-2*y0^2*x1*x0-2*y0*x0^2*y1+y0^2*x1^2+x1^2*y1^2+4*y 0*x1*x0*y1-2*x1*x0*y1^2+x0^2*y1^2-2*y0*x1^2*y1+y0^2*x0^2)*z0*y1"); 
  
  return 0; 
}

